--- tarsnap-1.0.29/libarchive/archive_entry_private.h	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_entry_private.h	2011-06-19 17:55:10.000000000 -0700
@@ -97,10 +97,15 @@
 	 */
 
 	/*
-	 * Read archive_entry_copy_stat.c for an explanation of why I
-	 * don't just use "struct stat" instead of "struct aest" here
-	 * and why I have this odd pointer to a separately-allocated
-	 * struct stat.
+	 * We have a "struct aest" for holding file metadata rather than just
+	 * a "struct stat" because on some platforms the "struct stat" has
+	 * fields which are too narrow to hold the range of possible values;
+	 * we don't want to lose information if we read an archive and write
+	 * out another (e.g., in "tar -cf new.tar @old.tar").
+	 *
+	 * The "stat" pointer points to some form of platform-specific struct
+	 * stat; it is declared as a void * rather than a struct stat * as
+	 * some platforms have multiple varieties of stat structures.
 	 */
 	void *stat;
 	int  stat_valid; /* Set to 0 whenever a field in aest changes. */
--- tarsnap-1.0.29/libarchive/archive_read.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read.c	2011-08-08 13:53:11.000000000 -0700
@@ -70,6 +70,7 @@
 	if (!inited) {
 		av.archive_finish = _archive_read_finish;
 		av.archive_close = _archive_read_close;
+		inited = 1;
 	}
 	return (&av);
 }
@@ -169,7 +170,6 @@
 	a = (struct archive_read *)_a;
 	__archive_check_magic(&a->archive, ARCHIVE_READ_MAGIC,
 	    ARCHIVE_STATE_NEW, "archive_read_set_filter_options");
-	filter = a->filter;
 	len = 0;
 	for (filter = a->filter; filter != NULL; filter = filter->upstream) {
 		bidder = filter->bidder;
@@ -474,7 +474,7 @@
 	best_bid = -1;
 	best_bid_slot = -1;
 
-	/* Set up a->format and a->pformat_data for convenience of bidders. */
+	/* Set up a->format for convenience of bidders. */
 	a->format = &(a->formats[0]);
 	for (i = 0; i < slots; i++, a->format++) {
 		if (a->format->bid) {
@@ -729,7 +729,7 @@
 	if (a->format->read_data == NULL) {
 		archive_set_error(&a->archive, ARCHIVE_ERRNO_PROGRAMMER,
 		    "Internal error: "
-		    "No format_read_data_block function registered");
+		    "No format->read_data function registered");
 		return (ARCHIVE_FATAL);
 	}
 
@@ -959,7 +959,7 @@
  * possible.
  *
  * Mostly, this code returns pointers directly into the block of data
- * provided by the client_read routine.  It can do this unless the
+ * provided by the client's read routine.  It can do this unless the
  * request would split across blocks.  In that case, we have to copy
  * into an internal buffer to combine reads.
  */
@@ -1229,10 +1229,8 @@
 	 * have to use ordinary reads to finish out the request.
 	 */
 	while (request > 0) {
-		const void* dummy_buffer;
 		ssize_t bytes_read;
-		dummy_buffer = __archive_read_ahead(filter->archive,
-		    1, &bytes_read);
+		(void)__archive_read_ahead(filter->archive, 1, &bytes_read);
 		if (bytes_read < 0)
 			return (bytes_read);
 		if (bytes_read == 0) {
--- tarsnap-1.0.29/libarchive/archive_read_disk.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_disk.c	2011-08-08 11:36:26.000000000 -0700
@@ -47,6 +47,7 @@
 	if (!inited) {
 		av.archive_finish = _archive_read_finish;
 		av.archive_close = _archive_read_close;
+		inited = 1;
 	}
 	return (&av);
 }
--- tarsnap-1.0.29/libarchive/archive_read_disk_set_standard_lookup.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_disk_set_standard_lookup.c	2011-06-07 15:50:14.000000000 -0700
@@ -186,6 +186,8 @@
 lookup_uname_helper(struct name_cache *cache, id_t id)
 {
 	struct passwd	pwent, *result;
+	char * nbuff;
+	size_t nbuff_size;
 	int r;
 
 	if (cache->buff_size == 0) {
@@ -206,10 +208,12 @@
 		 * we just double it and try again.  Because the buffer
 		 * is kept around in the cache object, we shouldn't
 		 * have to do this very often. */
-		cache->buff_size *= 2;
-		cache->buff = realloc(cache->buff, cache->buff_size);
-		if (cache->buff == NULL)
+		nbuff_size = cache->buff_size * 2;
+		nbuff = realloc(cache->buff, nbuff_size);
+		if (nbuff == NULL)
 			break;
+		cache->buff = nbuff;
+		cache->buff_size = nbuff_size;
 	}
 	if (r != 0) {
 		archive_set_error(cache->archive, errno,
@@ -234,6 +238,8 @@
 lookup_gname_helper(struct name_cache *cache, id_t id)
 {
 	struct group	grent, *result;
+	char * nbuff;
+	size_t nbuff_size;
 	int r;
 
 	if (cache->buff_size == 0) {
@@ -252,10 +258,12 @@
 		/* ERANGE means our buffer was too small, but POSIX
 		 * doesn't tell us how big the buffer should be, so
 		 * we just double it and try again. */
-		cache->buff_size *= 2;
-		cache->buff = realloc(cache->buff, cache->buff_size);
-		if (cache->buff == NULL)
+		nbuff_size = cache->buff_size * 2;
+		nbuff = realloc(cache->buff, nbuff_size);
+		if (nbuff == NULL)
 			break;
+		cache->buff = nbuff;
+		cache->buff_size = nbuff_size;
 	}
 	if (r != 0) {
 		archive_set_error(cache->archive, errno,
--- tarsnap-1.0.29/libarchive/archive_read_extract.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_extract.c	2011-08-12 08:59:26.000000000 -0700
@@ -73,7 +73,10 @@
 			archive_set_error(&a->archive, ENOMEM, "Can't extract");
 			return (NULL);
 		}
-		archive_write_disk_set_standard_lookup(a->extract->ad);
+		if (archive_write_disk_set_standard_lookup(a->extract->ad)) {
+			archive_set_error(&a->archive, ENOMEM, "Can't extract");
+			return (NULL);
+		}
 		a->cleanup_archive_extract = archive_read_extract_cleanup;
 	}
 	return (a->extract);
@@ -106,7 +109,7 @@
 		r = ARCHIVE_WARN;
 	if (r != ARCHIVE_OK)
 		/* If _write_header failed, copy the error. */
- 		archive_copy_error(&a->archive, ad);
+		archive_copy_error(&a->archive, ad);
 	else
 		/* Otherwise, pour data into the entry. */
 		r = copy_data(_a, ad);
@@ -115,7 +118,7 @@
 		r2 = ARCHIVE_WARN;
 	/* Use the first message. */
 	if (r2 != ARCHIVE_OK && r == ARCHIVE_OK)
- 		archive_copy_error(&a->archive, ad);
+		archive_copy_error(&a->archive, ad);
 	/* Use the worst error return. */
 	if (r2 < r)
 		r = r2;
@@ -144,6 +147,8 @@
 	int r;
 
 	extract = get_extract((struct archive_read *)ar);
+	if (extract == NULL)
+		return (ARCHIVE_FATAL);
 	for (;;) {
 		r = archive_read_data_block(ar, &buff, &size, &offset);
 		if (r == ARCHIVE_EOF)
--- tarsnap-1.0.29/libarchive/archive_read_support_compression_compress.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_support_compression_compress.c	2011-06-26 02:25:33.000000000 -0700
@@ -229,8 +229,8 @@
 
 	/* XXX MOVE THE FOLLOWING OUT OF INIT() XXX */
 
-	code = getbits(self, 8); /* Skip first signature byte. */
-	code = getbits(self, 8); /* Skip second signature byte. */
+	(void)getbits(self, 8); /* Skip first signature byte. */
+	(void)getbits(self, 8); /* Skip second signature byte. */
 
 	code = getbits(self, 8);
 	state->maxcode_bits = code & 0x1f;
--- tarsnap-1.0.29/libarchive/archive_read_support_format_ar.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_support_format_ar.c	2011-06-26 02:23:39.000000000 -0700
@@ -136,7 +136,6 @@
 static int
 archive_read_format_ar_bid(struct archive_read *a)
 {
-	struct ar *ar;
 	const void *h;
 
 	if (a->archive.archive_format != 0 &&
@@ -144,8 +143,6 @@
 	    ARCHIVE_FORMAT_AR)
 		return(0);
 
-	ar = (struct ar *)(a->format->data);
-
 	/*
 	 * Verify the 8-byte file signature.
 	 * TODO: Do we need to check more than this?
--- tarsnap-1.0.29/libarchive/archive_read_support_format_empty.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_support_format_empty.c	2011-06-26 02:22:15.000000000 -0700
@@ -61,10 +61,9 @@
 static int
 archive_read_format_empty_bid(struct archive_read *a)
 {
-	const void *h;
 	ssize_t avail;
 
-	h = __archive_read_ahead(a, 1, &avail);
+	(void)__archive_read_ahead(a, 1, &avail);
 	if (avail != 0)
 		return (-1);
 	return (1);
--- tarsnap-1.0.29/libarchive/archive_read_support_format_iso9660.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_support_format_iso9660.c	2011-06-22 04:14:25.000000000 -0700
@@ -393,7 +393,7 @@
 
 	/* Note: The "warn" return is just to inform the options
 	 * supervisor that we didn't handle it.  It will generate
-	 * a suitable error if noone used this option. */
+	 * a suitable error if no one used this option. */
 	return (ARCHIVE_WARN);
 }
 
@@ -440,13 +440,6 @@
 	iso9660->volume_size = iso9660->logical_block_size
 	    * (uint64_t)toi(h + SVD_volume_space_size_offset, 4);
 
-#if DEBUG
-	fprintf(stderr, "Joliet UCS-2 level %d with "
-			"logical block size:%d, volume size:%d\n",
-			iso9660->seenJoliet,
-			iso9660->logical_block_size, iso9660->volume_size);
-#endif
-
 	/* Store the root directory in the pending list. */
 	file = parse_file_info(iso9660, NULL, h + SVD_root_directory_record_offset);
 	add_entry(iso9660, file);
@@ -774,7 +767,7 @@
 #if 0 /* untested code, is it at all useful on Joliet? */
 		/* trim trailing first version and dot from filename.
 		 *
-		 * Remember we where in UTF-16BE land!
+		 * Remember we were in UTF-16BE land!
 		 * SEPARATOR 1 (.) and SEPARATOR 2 (;) are both
 		 * 16 bits big endian characters on Joliet.
 		 *
@@ -906,7 +899,7 @@
 					    * iso9660->logical_block_size
 					    + toi(data + 8, 4);
 					file->ce_size = toi(data + 16, 4);
-					/* If the result is rediculous,
+					/* If the result is ridiculous,
 					 * ignore it. */
 					if (file->ce_offset + file->ce_size
 					    > iso9660->volume_size) {
--- tarsnap-1.0.29/libarchive/archive_read_support_format_mtree.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_support_format_mtree.c	2011-08-08 13:08:57.000000000 -0700
@@ -98,7 +98,7 @@
 
 	struct archive_entry_linkresolver *resolver;
 
-	off_t			 cur_size, cur_offset;
+	off_t			 cur_size;
 };
 
 static int	cleanup(struct archive_read *);
@@ -398,7 +398,6 @@
 
 	global = NULL;
 	last_entry = NULL;
-	r = ARCHIVE_OK;
 
 	for (counter = 1; ; ++counter) {
 		len = readline(a, mtree, &p, 256);
@@ -1148,28 +1147,43 @@
 	int base, digit, sign;
 
 	base = 10;
-	limit = INT64_MAX / base;
-	last_digit_limit = INT64_MAX % base;
 
 	if (**p == '-') {
 		sign = -1;
+		limit = ((uint64_t)(INT64_MAX) + 1) / base;
+		last_digit_limit = ((uint64_t)(INT64_MAX) + 1) % base;
 		++(*p);
-	} else
+	} else {
 		sign = 1;
+		limit = INT64_MAX / base;
+		last_digit_limit = INT64_MAX % base;
+	}
 
 	l = 0;
 	digit = **p - '0';
 	while (digit >= 0 && digit < base) {
-		if (l > limit || (l == limit && digit > last_digit_limit)) {
-			l = UINT64_MAX; /* Truncate on overflow. */
-			break;
-		}
+		if (l > limit || (l == limit && digit > last_digit_limit))
+			return (sign < 0) ? INT64_MIN : INT64_MAX;
 		l = (l * base) + digit;
 		digit = *++(*p) - '0';
 	}
 	return (sign < 0) ? -l : l;
 }
 
+/* Parse a hex digit. */
+static int
+parsehex(char c)
+{
+	if (c >= '0' && c <= '9')
+		return c - '0';
+	else if (c >= 'a' && c <= 'f')
+		return c - 'a';
+	else if (c >= 'A' && c <= 'F')
+		return c - 'A';
+	else
+		return -1;
+}
+
 /*
  * Note that this implementation does not (and should not!) obey
  * locale settings; you cannot simply substitute strtol here, since
@@ -1182,38 +1196,25 @@
 	int base, digit, sign;
 
 	base = 16;
-	limit = INT64_MAX / base;
-	last_digit_limit = INT64_MAX % base;
 
 	if (**p == '-') {
 		sign = -1;
+		limit = ((uint64_t)(INT64_MAX) + 1) / base;
+		last_digit_limit = ((uint64_t)(INT64_MAX) + 1) % base;
 		++(*p);
-	} else
+	} else {
 		sign = 1;
+		limit = INT64_MAX / base;
+		last_digit_limit = INT64_MAX % base;
+	}
 
 	l = 0;
-	if (**p >= '0' && **p <= '9')
-		digit = **p - '0';
-	else if (**p >= 'a' && **p <= 'f')
-		digit = **p - 'a' + 10;
-	else if (**p >= 'A' && **p <= 'F')
-		digit = **p - 'A' + 10;
-	else
-		digit = -1;
+	digit = parsehex(**p);
 	while (digit >= 0 && digit < base) {
-		if (l > limit || (l == limit && digit > last_digit_limit)) {
-			l = UINT64_MAX; /* Truncate on overflow. */
-			break;
-		}
+		if (l > limit || (l == limit && digit > last_digit_limit))
+			return (sign < 0) ? INT64_MIN : INT64_MAX;
 		l = (l * base) + digit;
-		if (**p >= '0' && **p <= '9')
-			digit = **p - '0';
-		else if (**p >= 'a' && **p <= 'f')
-			digit = **p - 'a' + 10;
-		else if (**p >= 'A' && **p <= 'F')
-			digit = **p - 'A' + 10;
-		else
-			digit = -1;
+		digit = parsehex(*++(*p));
 	}
 	return (sign < 0) ? -l : l;
 }
--- tarsnap-1.0.29/libarchive/archive_read_support_format_tar.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_support_format_tar.c	2011-08-08 13:04:54.000000000 -0700
@@ -368,7 +368,7 @@
 }
 
 /*
- * The function invoked by archive_read_header().  This
+ * The function invoked by archive_read_next_header().  This
  * just sets up a few things and then calls the internal
  * tar_read_header() function below.
  */
@@ -593,7 +593,7 @@
 		return (bytes);
 	if (bytes < 512) {  /* Short read or EOF. */
 		/* Try requesting just one byte and see what happens. */
-		h = __archive_read_ahead(a, 1, &bytes);
+		(void)__archive_read_ahead(a, 1, &bytes);
 		if (bytes == 0) {
 			/*
 			 * The archive ends at a 512-byte boundary but
@@ -896,7 +896,7 @@
 		return (ARCHIVE_FATAL);
 	}
 
- 	/* Read the body into the string. */
+	/* Read the body into the string. */
 	padded_size = (size + 511) & ~ 511;
 	src = __archive_read_ahead(a, padded_size, NULL);
 	if (src == NULL)
@@ -1200,7 +1200,7 @@
     struct archive_entry *entry, char *attr)
 {
 	size_t attr_length, l, line_length;
-	char *line, *p;
+	char *p;
 	char *key, *value;
 	int err, err2;
 
@@ -1216,7 +1216,7 @@
 		/* Parse decimal length field at start of line. */
 		line_length = 0;
 		l = attr_length;
-		line = p = attr; /* Record start of line. */
+		p = attr; /* Record start of line. */
 		while (l>0) {
 			if (*p == ' ') {
 				p++;
@@ -1828,7 +1828,7 @@
  * Beginning with GNU tar 1.15, sparse files are stored using
  * information in the pax extended header.  The GNU tar maintainers
  * have gone through a number of variations in the process of working
- * out this scheme; furtunately, they're all numbered.
+ * out this scheme; fortunately, they're all numbered.
  *
  * Sparse format 0.0 uses attribute GNU.sparse.numblocks to store the
  * number of blocks, and GNU.sparse.offset/GNU.sparse.numbytes to
@@ -2193,7 +2193,7 @@
 
 	/* Ensure pax_entry buffer is big enough. */
 	if (tar->pax_entry_length <= length) {
-		wchar_t *old_entry = tar->pax_entry;
+		wchar_t *old_entry;
 
 		if (tar->pax_entry_length <= 0)
 			tar->pax_entry_length = 1024;
--- tarsnap-1.0.29/libarchive/archive_read_support_format_zip.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_read_support_format_zip.c	2011-06-11 13:05:25.000000000 -0700
@@ -900,7 +900,7 @@
 	if (offset != zip->extra_length)
 	{
 		fprintf(stderr,
-		    "Extra data field contents do not match reported size!");
+		    "Extra data field contents do not match reported size!\n");
 	}
 #endif
 }
--- tarsnap-1.0.29/libarchive/archive_string.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_string.c	2011-08-06 17:48:04.000000000 -0700
@@ -99,6 +99,9 @@
 struct archive_string *
 __archive_string_ensure(struct archive_string *as, size_t s)
 {
+	char *p;
+	size_t new_length;
+
 	/* If buffer is already big enough, don't reallocate. */
 	if (as->s && (s <= as->buffer_length))
 		return (as);
@@ -112,18 +115,17 @@
 	 */
 	if (as->buffer_length < 32)
 		/* Start with a minimum 32-character buffer. */
-		as->buffer_length = 32;
+		new_length = 32;
 	else if (as->buffer_length < 8192)
 		/* Buffers under 8k are doubled for speed. */
-		as->buffer_length += as->buffer_length;
+		new_length = as->buffer_length + as->buffer_length;
 	else {
 		/* Buffers 8k and over grow by at least 25% each time. */
-		size_t old_length = as->buffer_length;
-		as->buffer_length += as->buffer_length / 4;
-		/* Be safe: If size wraps, release buffer and return NULL. */
-		if (as->buffer_length < old_length) {
-			free(as->s);
-			as->s = NULL;
+		new_length = as->buffer_length + as->buffer_length / 4;
+		/* Be safe: If size wraps, fail. */
+		if (new_length < as->buffer_length) {
+			/* On failure, wipe the string and return NULL. */
+			__archive_string_free(as);
 			return (NULL);
 		}
 	}
@@ -132,12 +134,18 @@
 	 * grow the buffer.  In any case, we have to grow it enough to
 	 * hold the request.
 	 */
-	if (as->buffer_length < s)
-		as->buffer_length = s;
+	if (new_length < s)
+		new_length = s;
 	/* Now we can reallocate the buffer. */
-	as->s = (char *)realloc(as->s, as->buffer_length);
-	if (as->s == NULL)
+	p = (char *)realloc(as->s, new_length);
+	if (p == NULL) {
+		/* On failure, wipe the string and return NULL. */
+		__archive_string_free(as);
 		return (NULL);
+	}
+
+	as->s = p;
+	as->buffer_length = new_length;
 	return (as);
 }
 
@@ -289,18 +297,17 @@
 {
 	wchar_t *ws, *dest;
 	int wc, wc2;/* Must be large enough for a 21-bit Unicode code point. */
-	const char *src;
+	const char *src, *end;
 	int n;
-	int err;
 
 	ws = (wchar_t *)malloc((as->length + 1) * sizeof(wchar_t));
 	if (ws == NULL)
 		__archive_errx(1, "Out of memory");
-	err = 0;
 	dest = ws;
 	src = as->s;
+	end = as->s + as->buffer_length;
 	while (*src != '\0') {
-		n = utf8_to_unicode(&wc, src, 8);
+		n = utf8_to_unicode(&wc, src, end - src);
 		if (n == 0)
 			break;
 		if (n < 0) {
@@ -313,7 +320,7 @@
 			 * has translated UTF16 to UTF8 without combining
 			 * surrogates; rebuild the full code point before
 			 * continuing. */
-			n = utf8_to_unicode(&wc2, src, 8);
+			n = utf8_to_unicode(&wc2, src, end - src);
 			if (n < 0) {
 				free(ws);
 				return (NULL);
--- tarsnap-1.0.29/libarchive/archive_string_sprintf.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_string_sprintf.c	2011-08-16 12:01:35.000000000 -0700
@@ -60,11 +60,14 @@
 static void
 append_int(struct archive_string *as, intmax_t d, unsigned base)
 {
+	uintmax_t ud;
+
 	if (d < 0) {
 		archive_strappend_char(as, '-');
-		d = -d;
-	}
-	append_uint(as, d, base);
+		ud = (d == INTMAX_MIN) ? (uintmax_t)(INTMAX_MAX) + 1 : (uintmax_t)(-d);
+	} else
+		ud = d;
+	append_uint(as, ud, base);
 }
 
 
--- tarsnap-1.0.29/libarchive/archive_windows.h	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_windows.h	2011-05-30 06:04:22.000000000 -0700
@@ -334,7 +334,7 @@
 #define WIFEXITED(sts)		((sts & 0x100) == 0)
 #define WEXITSTATUS(sts)	(sts & 0x0FF)
 
-/* Convertion a Win32 API error code */
+/* Convert a Win32 API error code */
 extern void _dosmaperr(unsigned long);
 
 /* Message digest function */
--- tarsnap-1.0.29/libarchive/archive_write.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write.c	2011-08-08 11:36:15.000000000 -0700
@@ -29,7 +29,7 @@
 /*
  * This file contains the "essential" portions of the write API, that
  * is, stuff that will essentially always be used by any client that
- * actually needs to write a archive.  Optional pieces have been, as
+ * actually needs to write an archive.  Optional pieces have been, as
  * far as possible, separated out into separate files to reduce
  * needlessly bloating statically-linked clients.
  */
@@ -80,6 +80,7 @@
 		av.archive_write_header = _archive_write_header;
 		av.archive_write_finish_entry = _archive_write_finish_entry;
 		av.archive_write_data = _archive_write_data;
+		inited = 1;
 	}
 	return (&av);
 }
@@ -315,7 +316,6 @@
 	struct archive_write *a = (struct archive_write *)_a;
 	int ret;
 
-	ret = ARCHIVE_OK;
 	__archive_check_magic(&a->archive, ARCHIVE_WRITE_MAGIC,
 	    ARCHIVE_STATE_NEW, "archive_write_open");
 	archive_clear_error(&a->archive);
--- tarsnap-1.0.29/libarchive/archive_write_disk.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_disk.c	2011-08-08 11:36:37.000000000 -0700
@@ -205,7 +205,7 @@
 
 /*
  * Default mode for dirs created automatically (will be modified by umask).
- * Note that POSIX specifies 0777 for implicity-created dirs, "modified
+ * Note that POSIX specifies 0777 for implicitly-created dirs, "modified
  * by the process' file creation mask."
  */
 #define	DEFAULT_DIR_MODE 0777
@@ -273,7 +273,7 @@
 #endif
 	/*
 	 * XXX At this point, symlinks should not be hit, otherwise
-	 * XXX a race occured.  Do we want to check explicitly for that?
+	 * XXX a race occurred.  Do we want to check explicitly for that?
 	 */
 	if (lstat(a->name, &a->st) == 0) {
 		a->pst = &a->st;
@@ -296,6 +296,7 @@
 		av.archive_write_finish_entry = _archive_write_finish_entry;
 		av.archive_write_data = _archive_write_data;
 		av.archive_write_data_block = _archive_write_data_block;
+		inited = 1;
 	}
 	return (&av);
 }
@@ -455,7 +456,11 @@
 #ifdef HAVE_FCHDIR
 	/* If we changed directory above, restore it here. */
 	if (a->restore_pwd >= 0) {
-		fchdir(a->restore_pwd);
+		r = fchdir(a->restore_pwd);
+		if (r != 0) {
+			archive_set_error(&a->archive, errno, "chdir() failure");
+			ret = ARCHIVE_FATAL;
+		}
 		close(a->restore_pwd);
 		a->restore_pwd = -1;
 	}
@@ -612,7 +617,7 @@
 			a->fd_offset = a->offset;
 			a->archive.file_position = a->offset;
 			a->archive.raw_position = a->offset;
- 		}
+		}
 		bytes_written = write(a->fd, buff, bytes_to_write);
 		if (bytes_written < 0) {
 			archive_set_error(&a->archive, errno, "Write failed");
@@ -967,7 +972,7 @@
 		 */
 		int r = 0;
 		/*
-		 * The SECURE_SYMLINK logic has already removed a
+		 * The SECURE_SYMLINKS logic has already removed a
 		 * symlink to a dir if the client wants that.  So
 		 * follow the symlink if we're creating a dir.
 		 */
@@ -1501,7 +1506,7 @@
 		++alen;
 		if (*p == '\\')
 			l = 1;
-		/* Rewrite the path name if its character is a unusable. */
+		/* Rewrite the path name if its next character is unusable. */
 		if (*p == ':' || *p == '*' || *p == '?' || *p == '"' ||
 		    *p == '<' || *p == '>' || *p == '|')
 			*p = '_';
@@ -1661,8 +1666,6 @@
 	mode_t mode_final, mode;
 	int r;
 
-	r = ARCHIVE_OK;
-
 	/* Check for special names and just skip them. */
 	slash = strrchr(path, '/');
 	if (slash == NULL)
@@ -2210,22 +2213,25 @@
 	 * to read the current flags from disk. XXX
 	 */
 	ret = ARCHIVE_OK;
+
+	/* Read the current file flags. */
+	if (ioctl(myfd, EXT2_IOC_GETFLAGS, &oldflags) < 0)
+		goto fail;
+
 	/* Try setting the flags as given. */
-	if (ioctl(myfd, EXT2_IOC_GETFLAGS, &oldflags) >= 0) {
-		newflags = (oldflags & ~clear) | set;
-		if (ioctl(myfd, EXT2_IOC_SETFLAGS, &newflags) >= 0)
-			goto cleanup;
-		if (errno != EPERM)
-			goto fail;
-	}
+	newflags = (oldflags & ~clear) | set;
+	if (ioctl(myfd, EXT2_IOC_SETFLAGS, &newflags) >= 0)
+		goto cleanup;
+	if (errno != EPERM)
+		goto fail;
+
 	/* If we couldn't set all the flags, try again with a subset. */
-	if (ioctl(myfd, EXT2_IOC_GETFLAGS, &oldflags) >= 0) {
-		newflags &= ~sf_mask;
-		oldflags &= sf_mask;
-		newflags |= oldflags;
-		if (ioctl(myfd, EXT2_IOC_SETFLAGS, &newflags) >= 0)
-			goto cleanup;
-	}
+	newflags &= ~sf_mask;
+	oldflags &= sf_mask;
+	newflags |= oldflags;
+	if (ioctl(myfd, EXT2_IOC_SETFLAGS, &newflags) >= 0)
+		goto cleanup;
+
 	/* We couldn't set the flags, so report the failure. */
 fail:
 	archive_set_error(&a->archive, errno,
--- tarsnap-1.0.29/libarchive/archive_write_disk_set_standard_lookup.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_disk_set_standard_lookup.c	2011-08-14 13:43:21.000000000 -0700
@@ -86,6 +86,11 @@
 {
 	struct bucket *ucache = malloc(cache_size * sizeof(struct bucket));
 	struct bucket *gcache = malloc(cache_size * sizeof(struct bucket));
+	if (ucache == NULL || gcache == NULL) {
+		free(ucache);
+		free(gcache);
+		return (ARCHIVE_FATAL);
+	}
 	memset(ucache, 0, cache_size * sizeof(struct bucket));
 	memset(gcache, 0, cache_size * sizeof(struct bucket));
 	archive_write_disk_set_group_lookup(a, gcache, lookup_gid, cleanup);
--- tarsnap-1.0.29/libarchive/archive_write_set_compression_compress.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_set_compression_compress.c	2011-05-30 06:16:31.000000000 -0700
@@ -114,7 +114,7 @@
 		    const void *, size_t);
 
 /*
- * Allocate, initialize and return a archive object.
+ * Allocate, initialize and return an archive object.
  */
 int
 archive_write_set_compression_compress(struct archive *_a)
@@ -200,7 +200,7 @@
  * Output the given code.
  * Inputs:
  * 	code:	A n_bits-bit integer.  If == -1, then EOF.  This assumes
- *		that n_bits =< (long)wordsize - 1.
+ *		that n_bits <= (long)wordsize - 1.
  * Outputs:
  * 	Outputs code to the file.
  * Assumptions:
--- tarsnap-1.0.29/libarchive/archive_write_set_compression_gzip.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_set_compression_gzip.c	2011-05-30 06:16:24.000000000 -0700
@@ -87,7 +87,7 @@
 
 
 /*
- * Allocate, initialize and return a archive object.
+ * Allocate, initialize and return an archive object.
  */
 int
 archive_write_set_compression_gzip(struct archive *_a)
--- tarsnap-1.0.29/libarchive/archive_write_set_compression_none.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_set_compression_none.c	2011-06-22 04:07:48.000000000 -0700
@@ -225,7 +225,6 @@
 		block_length = state->buffer_size - state->avail;
 
 		/* Tricky calculation to determine size of last block */
-		target_block_length = block_length;
 		if (a->bytes_in_last_block <= 0)
 			/* Default or Zero: pad to full block */
 			target_block_length = a->bytes_per_block;
--- tarsnap-1.0.29/libarchive/archive_write_set_compression_program.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_set_compression_program.c	2011-05-30 06:15:31.000000000 -0700
@@ -83,7 +83,7 @@
 		    const void *, size_t);
 
 /*
- * Allocate, initialize and return a archive object.
+ * Allocate, initialize and return an archive object.
  */
 int
 archive_write_set_compression_program(struct archive *_a, const char *cmd)
--- tarsnap-1.0.29/libarchive/archive_write_set_compression_xz.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_set_compression_xz.c	2011-05-30 06:15:28.000000000 -0700
@@ -89,7 +89,7 @@
 
 
 /*
- * Allocate, initialize and return a archive object.
+ * Allocate, initialize and return an archive object.
  */
 int
 archive_write_set_compression_xz(struct archive *_a)
--- tarsnap-1.0.29/libarchive/archive_write_set_format_ar.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_set_format_ar.c	2011-05-30 05:59:32.000000000 -0700
@@ -191,7 +191,7 @@
 		ar->is_strtab = 1;
 		buff[AR_name_offset] = buff[AR_name_offset + 1] = '/';
 		/*
-		 * For archive string table, only ar_size filed should
+		 * For archive string table, only ar_size field should
 		 * be set.
 		 */
 		goto size;
@@ -502,7 +502,7 @@
 	len = s;
 	h = p;
 
-	/* Negative values in ar header are meaningless , so use 0. */
+	/* Negative values in ar header are meaningless, so use 0. */
 	if (v < 0) {
 		while (len-- > 0)
 			*p++ = '0';
--- tarsnap-1.0.29/libarchive/archive_write_set_format_pax.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_set_format_pax.c	2011-08-16 12:01:59.000000000 -0700
@@ -171,18 +171,17 @@
 static char *
 format_int(char *t, int64_t i)
 {
-	int sign;
+	uint64_t ui;
 
-	if (i < 0) {
-		sign = -1;
-		i = -i;
-	} else
-		sign = 1;
+	if (i < 0) 
+		ui = (i == INT64_MIN) ? (uint64_t)(INT64_MAX) + 1 : (uint64_t)(-i);
+	else
+		ui = i;
 
 	do {
-		*--t = "0123456789"[i % 10];
-	} while (i /= 10);
-	if (sign < 0)
+		*--t = "0123456789"[ui % 10];
+	} while (ui /= 10);
+	if (i < 0)
 		*--t = '-';
 	return (t);
 }
@@ -546,7 +545,7 @@
 		/* We have an all-ASCII path; we'd like to just store
 		 * it in the ustar header if it will fit.  Yes, this
 		 * duplicates some of the logic in
-		 * write_set_format_ustar.c
+		 * archive_write_set_format_ustar.c
 		 */
 		if (strlen(path) <= 100) {
 			/* Fits in the old 100-char tar name field. */
@@ -1138,7 +1137,7 @@
  *
  * Joerg Schilling has argued that this is unnecessary because, in
  * practice, if the pax extended attributes get extracted as regular
- * files, noone is going to bother reading those attributes to
+ * files, no one is going to bother reading those attributes to
  * manually restore them.  Based on this, 'star' uses
  * /tmp/PaxHeader/'basename' as the ustar header name.  This is a
  * tempting argument, in part because it's simpler than the SUSv3
@@ -1212,15 +1211,11 @@
 static int
 archive_write_pax_finish(struct archive_write *a)
 {
-	struct pax *pax;
-	int r;
 
 	if (a->compressor.write == NULL)
 		return (ARCHIVE_OK);
 
-	pax = (struct pax *)a->format_data;
-	r = write_nulls(a, 512 * 2);
-	return (r);
+	return (write_nulls(a, 512 * 2));
 }
 
 static int
--- tarsnap-1.0.29/libarchive/archive_write_set_format_ustar.c	2011-01-19 20:32:49.000000000 -0800
+++ tarsnap-1.0.30/libarchive/archive_write_set_format_ustar.c	2011-05-30 06:05:44.000000000 -0700
@@ -303,7 +303,7 @@
 			 * The only feasible separator is a final '/';
 			 * this would result in a non-empty prefix and
 			 * an empty name, which POSIX doesn't
-			 * explicity forbid, but it just feels wrong.
+			 * explicitly forbid, but it just feels wrong.
 			 */
 			archive_set_error(&a->archive, ENAMETOOLONG,
 			    "Pathname too long");
--- tarsnap-1.0.29/pkg/README	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/pkg/README	2011-04-24 00:26:28.000000000 -0700
@@ -27,13 +27,17 @@
 sha256sums= lines so that you get the latest version of tarsnap.
 
 There may be a newer version of the PKGBUILD file at
-  http://aur.archlinux.org/packages.php?ID=22963
+  http://www.archlinux.org/packages/community/i686/tarsnap/
+  http://www.archlinux.org/packages/community/x86_64/tarsnap/
+(in fact, those probably have identical PKGBUILD files).
 
 Slackware
 ---------
 
 There is a SlackBuild for tarsnap (possibly an earlier version) at
-  http://slackbuilds.org/repository/12.2/system/tarsnap/
+  http://slackbuilds.org/repository/${VER}/system/tarsnap/
+for VER = 12.2 and 13.1 (and possibly other versions by the time
+you read this).
 
 FreeBSD
 -------
--- tarsnap-1.0.29/pkg/archlinux/PKGBUILD	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/pkg/archlinux/PKGBUILD	2011-04-24 00:24:48.000000000 -0700
@@ -1,23 +1,29 @@
-# Contributor: Aaron Schaefer <aaron@elasticdog.com>
+# $Id$
+# Maintainer: Jelle van der Waa <jelle vd waa.nl>
+
 pkgname=tarsnap
-pkgver=1.0.25
+pkgver=1.0.29
 pkgrel=1
 pkgdesc='An online encrypted snapshotted backup service'
 arch=('i686' 'x86_64')
 url='http://www.tarsnap.com/'
 license=('custom')
-depends=('bzip2' 'openssl')
+depends=('bzip2' 'openssl' 'xz>=5.0.0')
 makedepends=('e2fsprogs')
 source=("https://www.tarsnap.com/download/$pkgname-autoconf-$pkgver.tgz")
-md5sums=('862403c3a79db9657d7ff9c898238e81')
-sha256sums=('086787dd9d9985590c17848454e7b4e31327c3a70065c5f2611b1e0a1fddb087')
+md5sums=('0e5ef12a92fb651b51159b1ad52317f6')
+sha256sums=('747510459e4af0ebbb6e267c159aa019f9337d1e07bd9a94f1aa1498081b7598')
 
 build() {
   cd "$srcdir/$pkgname-autoconf-$pkgver"
 
   ./configure --prefix=/usr --sysconfdir="/etc/$pkgname"
-  make || return 1
-  make DESTDIR="$pkgdir/" install || return 1
+  make
+}
+
+package() {
+  cd "$srcdir/$pkgname-autoconf-$pkgver"
 
+  make DESTDIR="$pkgdir" install
   install -D -m644 COPYING "$pkgdir/usr/share/licenses/$pkgname/COPYING"
 }
--- tarsnap-1.0.29/pkg/debian/changelog	2011-02-01 13:29:47.000000000 -0800
+++ tarsnap-1.0.30/pkg/debian/changelog	2011-08-16 13:25:41.000000000 -0700
@@ -1,3 +1,8 @@
+tarsnap (1.0.30) unstable; urgency=low
+
+  * New version of tarsnap brings many minor bug fixes.
+
+ -- Colin Percival <cperciva@tarsnap.com>  Tue, 16 Aug 2011 20:25:12 +0000
 tarsnap (1.0.29) unstable; urgency=low
 
   * New version of tarsnap adds tarsnap-recrypt utility for re-encrypting
